import mne
import os
import numpy as np
import pandas as pd
from mne.datasets import fetch_fsaverage

# Download fsaverage files
fs_dir = fetch_fsaverage(verbose=True)
subjects_dir = os.path.dirname(fs_dir)

# The files live in:
subject = 'fsaverage'
trans = 'fsaverage'  # MNE has a built-in fsaverage transformation
src = os.path.join(fs_dir, 'bem', 'fsaverage-ico-5-src.fif')
bem = os.path.join(fs_dir, 'bem', 'fsaverage-5120-5120-5120-bem-sol.fif')

# Only need to change name_subject and rem_namelist and bad channels
name_subject = 's243'

#rem_namelist = ['s0129-REM3-1.bdf','s0129-REM4-1.bdf','s0129-REM4-2.bdf','s0129-REM4-3.bdf','s0129-REM4-4.bdf'] # 's0129-REM1-1.bdf','s0129-REM2-1.bdf'
#rem_namelist = ['s0240adaptation-REM1-2.bdf','s0240adaptation-REM2-1.bdf','s0240adaptation-REM2-2.bdf','s0240adaptation-REM3-1.bdf','s0240adaptation-REM4-2.bdf','s0240adaptation-REM5-1.bdf'] # 's0240adaptation-REM1-1.bdf','s0240adaptation-REM4-1.bdf',
#rem_namelist = ['s0241REM1-1.bdf','s0241REM2-1.bdf','s0241REM3-1.bdf','s0241REM3-2.bdf','s0241REM4-1.bdf'] #'s0241REM3-3.bdf',
#rem_namelist = ['s0242adaptation-REM2-1.bdf','s0242adaptation-REM3-2.bdf','s0242adaptation-REM4-1.bdf','s0242adaptation-REM4-2.bdf','s0242adaptation-REM5-1.bdf','s0242adaptation-REM5-2.bdf','s0242adaptation-REM5-3.bdf'] # 's0242adaptation-REM1-1.bdf',,'s0242adaptation-REM5-4.bdf'
rem_namelist = ['s0243-REM1-1.bdf','s0243-REM1-2.bdf','s0243-REM2-2.bdf','s0243-REM3-1.bdf','s0243-REM3-3.bdf','s0243-REM3-4.bdf','s0243-REM3-5.bdf'] #'s0243-REM2-1.bdf', ,'s0243-REM3-2.bdf' ,'s0243-REM3-6.bdf'
#rem_namelist = ['s0247adaptation-REM1-1.bdf','s0247adaptation-REM1-2.bdf','s0247adaptation-REM1-4.bdf','s0247adaptation-REM1-5.bdf','s0247adaptation-REM1-6.bdf','s0247adaptation-REM2-1.bdf','s0247adaptation-REM2-2.bdf','s0247adaptation-REM2-3.bdf','s0247adaptation-REM2-4.bdf','s0247adaptation-REM2-5.bdf','s0247adaptation-REM3-2.bdf','s0247adaptation-REM3-4.bdf','s0247adaptation-REM3-5.bdf','s0247adaptation-REM3-6.bdf','s0247adaptation-REM3-7.bdf','s0247adaptation-REM3-8.bdf'] # 's0247adaptation-REM1-3.bdf', 's0247adaptation-REM3-1.bdf','s0247adaptation-REM3-3.bdf',
#rem_namelist = ['s0248-REM1-1.bdf','s0248-REM2-1.bdf','s0248-REM2-2.bdf','s0248-REM2-3.bdf','s0248-REM3-1.bdf','s0248-REM3-2.bdf','s0248-REM4-2.bdf','s0248-REM4-3.bdf','s0248-REM4-4.bdf','s0248-REM5-1.bdf','s0248-REM5-2.bdf'] # 's0248-REM1-2.bdf', ,'s0248-REM3-3.bdf''s0248-REM4-1.bdf',
#rem_namelist = ['s0300-REM1-1.bdf','s0300-REM1-2.bdf','s0300-REM2-1.bdf','s0300-REM3-1.bdf'] # ,'s0300-REM1-3.bdf' 's0300-REM1-4.bdf','s0300-REM2-2.bdf', ,'s0300-REM3-2.bdf' ,'s0300-REM2-3.bdf'
epochs_list = []
for file_name in rem_namelist:
    # if file_name == 's0248-REM4-1.bdf':
    #     continue
    data_path = os.path.expanduser("C:/Users/oledr/Desktop/Sleep Data 128ch/REM only/{}/".format(name_subject))
    raw_fname = os.path.join(data_path,file_name)
    raw = mne.io.read_raw_bdf(raw_fname, preload=False) # False
    sfreq = raw.info['sfreq']

    ################### SETUP CHANNEL NAME AND MONTAGE ###################
    channel_name = ['A1', 'A2', 'A3', 'A4', 'A5', 'A6', 'A7', 'A8', 'A9', 'A10',  'A11','A12', 'A13', 'A14', 'A15', 'A16', 'A17', 'A18', 'A19', 'A20', 'A21','A22', 'A23', 'A24', 'A25', 'A26', 'A27', 'A28', 'A29', 'A30', 'A31','A32', 'B1', 'B2', 'B3', 'B4', 'B5', 'B6','B7', 'B8', 'B9', 'B10','B11', 'B12', 'B13', 'B14', 'B15', 'B16', 'B17', 'B18', 'B19', 'B20','B21', 'B22', 'B23', 'B24', 'B25', 'B26', 'B27', 'B28', 'B29', 'B30','B31', 'B32', 'C1', 'C2', 'C3', 'C4', 'C5', 'C6', 'C7', 'C8', 'C9','C10', 'C11', 'C12', 'C13', 'C14', 'C15', 'C16', 'C17', 'C18', 'C19','C20', 'C21', 'C22', 'C23', 'C24', 'C25', 'C26', 'C27', 'C28', 'C29','C30', 'C31', 'C32', 'D1', 'D2', 'D3', 'D4', 'D5', 'D6', 'D7', 'D8','D9', 'D10', 'D11', 'D12', 'D13', 'D14', 'D15', 'D16', 'D17', 'D18','D19', 'D20', 'D21', 'D22', 'D23', 'D24', 'D25', 'D26', 'D27', 'D28','D29', 'D30', 'D31', 'D32']

    mapping = dict()
    for i, name in enumerate(channel_name):
        mapping[raw.ch_names[i]] = name
    mne.rename_channels(raw.info, mapping)                                                                                          #}#
    channel_dict = {'EMG-c':'emg','EMG-l':'emg','EMG-r':'emg','EOG-u': 'eog','EOG-l':'eog','EOG-r': 'eog','M1': 'misc', 'M2': 'misc'}#, 'GSR1': 'misc', 'GSR2': 'misc', 'Erg1': 'misc', 'Erg2': 'misc', 'Resp': 'misc', 'Plet': 'misc', 'Temp': 'misc'}
    raw.set_channel_types(channel_dict)

    montage = mne.channels.make_standard_montage('biosemi128', head_size=0.095)
    raw.set_montage(montage)
    mne.set_eeg_reference(raw,ref_channels='average',projection=True)#['M1'])
    ################### SETUP CHANNEL NAME AND MONTAGE END ###################


    ##############################  MAKE EPOCHS ###############################

    df = pd.read_csv('C:/Users/oledr/Desktop/Sleep Data 128ch/REM only/{}/events corrected/{}.csv'.format(name_subject,file_name[0:-4]))
    events_from_csv = np.zeros(shape=(len(df), 3), dtype=int)
    for index, row in df.iterrows():
        if name_subject == 's248' or name_subject == 's243' or name_subject =='s300':
            if row[0][11] == 'E':
                events_from_csv[index, 0] = int(float(row[0][1:10]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][12] == 'E':
                events_from_csv[index, 0] = int(float(row[0][1:11]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][13] == 'E':
                events_from_csv[index, 0] = int(float(row[0][1:12]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][14] == 'E':
                events_from_csv[index, 0] = int(float(row[0][1:13]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][15] == 'E':
                events_from_csv[index, 0] = int(float(row[0][1:14]) * 1024)
                events_from_csv[index, 2] = 1
        else:
            if row[0][11] == ';':
                events_from_csv[index, 0] = int(float(row[0][1:11]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][13] == ';':
                events_from_csv[index, 0] = int(float(row[0][1:13]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][12] == ';':
                events_from_csv[index, 0] = int(float(row[0][1:12]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][10] == ';':
                events_from_csv[index, 0] = int(float(row[0][1:10]) * 1024)
                events_from_csv[index, 2] = 1

    event = events_from_csv
    # event_fname_extra = '_annotations_Furuki.txt'
    # event_new_fname = 'C:/Users/oledr/Desktop/Sleep Data 128ch/REM only/{}/events corrected/{}{}'.format(name_subject,file_name[0:-4],event_fname_extra)
    # events_from_file = mne.read_events(event_new_fname)
    # event = events_from_file
    if len(event) < 1:
        continue
    # s129 no bad channels
    #raw.drop_channels(['A31']) # s240
    #raw.drop_channels(['B25','B26','B28','C30']) # s241
    #raw.drop_channels(['A17','B3','B4','B13','C1','C31','D1','D18','D20','D21','D24']) #s242
    raw.drop_channels(['B19']) # s243
    #raw.drop_channels(['A1','A2','B1','B3']) # s247
    #raw.drop_channels(['A1']) # s248
    #raw.drop_channels(['A31','A32','B3','B19']) # s300
    tmin,tmax = -8,9
    epochs = mne.Epochs(raw,events=event,tmin=tmin,tmax=tmax,preload=True)#,baseline=(-0.2,-0.15))
    low_freq,high_freq = 0,300
    epochs.filter(low_freq,high_freq)#,filter_length=500)
    mne.filter.notch_filter(epochs,sfreq,50)
    epochs.crop(-0.2,0.05) ################### epochs lenght???
    #evoked = epochs.average()
    epochs_list.append(epochs)

epochs = mne.concatenate_epochs(epochs_list=epochs_list)
epochs.apply_baseline((-0.2,-0.15))
evoked = epochs.average()
evoked.plot()

##############################  MAKE EPOCHS END ###############################

############# SAVE AND LOAD EPOCHS ######################
#
name = '{}-epochs.fif'.format(name_subject)
fname_epochs = 'C:/Users/oledr/Desktop/Sleep Data 128ch/REM only/{}/'.format(name_subject) + name
epochs.save(fname_epochs)


# epochs_from_file = mne.read_epochs(fname_epochs)
############# SAVE AND LOAD EPOCHS END ######################


