import mne
import os
import numpy as np
import pandas as pd
from mne.datasets import fetch_fsaverage

# Download fsaverage files
fs_dir = fetch_fsaverage(verbose=True)
subjects_dir = os.path.dirname(fs_dir)

# The files live in:
subject = 'fsaverage'
trans = 'fsaverage'  # MNE has a built-in fsaverage transformation
src = os.path.join(fs_dir, 'bem', 'fsaverage-ico-5-src.fif')
bem = os.path.join(fs_dir, 'bem', 'fsaverage-5120-5120-5120-bem-sol.fif')

name_subject = 's300'

#rem_namelist = ['s0129-REM3-1.bdf','s0129-REM4-1.bdf','s0129-REM4-2.bdf','s0129-REM4-3.bdf','s0129-REM4-4.bdf'] # 's0129-REM1-1.bdf','s0129-REM2-1.bdf'
#rem_namelist = ['s0240adaptation-REM1-2.bdf','s0240adaptation-REM2-1.bdf','s0240adaptation-REM2-2.bdf','s0240adaptation-REM3-1.bdf','s0240adaptation-REM4-2.bdf','s0240adaptation-REM5-1.bdf'] # 's0240adaptation-REM1-1.bdf','s0240adaptation-REM4-1.bdf',
#rem_namelist = ['s0241REM1-1.bdf','s0241REM2-1.bdf','s0241REM3-1.bdf','s0241REM3-2.bdf','s0241REM4-1.bdf'] #'s0241REM3-3.bdf',
#rem_namelist = ['s0242adaptation-REM2-1.bdf','s0242adaptation-REM3-2.bdf','s0242adaptation-REM4-1.bdf','s0242adaptation-REM4-2.bdf','s0242adaptation-REM5-1.bdf','s0242adaptation-REM5-2.bdf','s0242adaptation-REM5-3.bdf'] # 's0242adaptation-REM1-1.bdf',,'s0242adaptation-REM5-4.bdf'
#rem_namelist = ['s0243-REM1-1.bdf','s0243-REM1-2.bdf','s0243-REM2-2.bdf','s0243-REM3-1.bdf','s0243-REM3-3.bdf','s0243-REM3-4.bdf','s0243-REM3-5.bdf'] # ,'s0243-REM3-2.bdf' ,'s0243-REM3-6.bdf'
#rem_namelist = ['s0247adaptation-REM1-1.bdf','s0247adaptation-REM1-2.bdf','s0247adaptation-REM1-4.bdf','s0247adaptation-REM1-5.bdf','s0247adaptation-REM1-6.bdf','s0247adaptation-REM2-1.bdf','s0247adaptation-REM2-2.bdf','s0247adaptation-REM2-3.bdf','s0247adaptation-REM2-4.bdf','s0247adaptation-REM2-5.bdf','s0247adaptation-REM3-2.bdf','s0247adaptation-REM3-4.bdf','s0247adaptation-REM3-5.bdf','s0247adaptation-REM3-6.bdf','s0247adaptation-REM3-7.bdf','s0247adaptation-REM3-8.bdf'] # 's0247adaptation-REM1-3.bdf', 's0247adaptation-REM3-1.bdf','s0247adaptation-REM3-3.bdf',
#rem_namelist = ['s0248-REM1-1.bdf','s0248-REM2-1.bdf','s0248-REM2-2.bdf','s0248-REM2-3.bdf','s0248-REM3-1.bdf','s0248-REM3-2.bdf','s0248-REM4-2.bdf','s0248-REM4-3.bdf','s0248-REM4-4.bdf','s0248-REM5-1.bdf','s0248-REM5-2.bdf'] # 's0248-REM1-2.bdf', ,'s0248-REM3-3.bdf''s0248-REM4-1.bdf',
rem_namelist = ['s0300-REM1-1.bdf','s0300-REM1-2.bdf','s0300-REM2-1.bdf','s0300-REM3-1.bdf'] # ,'s0300-REM1-3.bdf' 's0300-REM1-4.bdf','s0300-REM2-2.bdf', ,'s0300-REM3-2.bdf' ,'s0300-REM2-3.bdf'
TruePositive = []
FalseNegative = []
FalsePositive = []
all_points = []
distance = []
for file_name in rem_namelist:

    df = pd.read_csv('C:/Users/oledr/Desktop/Sleep Data 128ch/REM only/{}/events corrected/{}.csv'.format(name_subject,file_name[0:-4]))
    events_from_csv = np.zeros(shape=(len(df), 3), dtype=int)
    for index, row in df.iterrows():
        if name_subject == 's248' or name_subject == 's243' or 's300':
            if row[0][11] == 'E':
                events_from_csv[index, 0] = int(float(row[0][1:10]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][12] == 'E':
                events_from_csv[index, 0] = int(float(row[0][1:11]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][13] == 'E':
                events_from_csv[index, 0] = int(float(row[0][1:12]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][14] == 'E':
                events_from_csv[index, 0] = int(float(row[0][1:13]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][15] == 'E':
                events_from_csv[index, 0] = int(float(row[0][1:14]) * 1024)
                events_from_csv[index, 2] = 1
        else:
            if row[0][11] == ';':
                events_from_csv[index, 0] = int(float(row[0][1:11]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][13] == ';':
                events_from_csv[index, 0] = int(float(row[0][1:13]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][12] == ';':
                events_from_csv[index, 0] = int(float(row[0][1:12]) * 1024)
                events_from_csv[index, 2] = 1
            elif row[0][10] == ';':
                events_from_csv[index, 0] = int(float(row[0][1:10]) * 1024)
                events_from_csv[index, 2] = 1


    events_corrected = events_from_csv[:,0]



    ################# my events
    eve_name = '{}-eve.fif'.format(file_name[0:-4]) #
    event_new_fname = 'C:/Users/oledr/Desktop/Sleep Data 128ch/REM only/{}/events/'.format(name_subject) + eve_name
    events_algo = mne.read_events(event_new_fname)[:,0]


    closeness_criteria = 0.05
    print("With {} second as criteria for closeness".format(closeness_criteria))
    def brude_force_event_data(event_corrected,event_algo):
        true_positive = []
        false_positive = []
        false_negative = []
        all_events = []
        for i, event in enumerate(event_corrected):
            element_closest = min(event_algo, key=lambda x: abs(x - event))
            index = np.where(event_algo == element_closest)[0][0]
            distance = abs(event_corrected[i]-event_algo[index])
            if distance < closeness_criteria*1024:
                true_positive.append([event,i,element_closest,index,distance])
                all_events.append([event, i, element_closest, index, distance,'TP'])
            else:
                all_events.append([event, i, element_closest, index, distance,'FN'])
                false_negative.append([event,i])

        algo_elements_in_true_positive = [x[2] for x in true_positive]
        for i, event in enumerate(event_algo):
            # check if element is in true positive
            if event in algo_elements_in_true_positive:
                continue
            false_positive.append([event,i])
            element_closest = min(event_corrected, key=lambda x: abs(x - event))
            index = np.where(event_corrected == element_closest)[0][0]
            distance = abs(event_algo[i] - event_corrected[index])
            all_events.append([element_closest, index, event, i, distance,'FP'])

        return true_positive,false_negative,false_positive,all_events
    TP,FN,FP,all = brude_force_event_data(events_corrected,events_algo)
    TruePositive.extend(TP)
    FalseNegative.extend(FN)
    FalsePositive.extend(FP)
    all_points.extend(all)
    print('nr of: TP = {}, FN = {}, FP = {}, all = {}'.format(len(TP),len(FN),len(FP),len(all)))
    def most_common(lst):
        return max(set(lst), key=lst.count)

    if len(TP) > 1:
        ########### Find True positive Find events closer then 0.05 secound (300hz*0.05 = 15 points) away from profesional marked point
        ave_distance = sum([x[4] for x in TP])/len(TP)
        d = [x[4] for x in TP]
        distance.extend(d)
        print('average distance is {} points or {} seconds'.format(round(ave_distance,2),round(ave_distance/1024,5)))

        # Precision = True positives/ (True positives + False positives)
        precision = len(TP)/(len(TP)+len(FP))
        # Recall = True positives / (True positives + False negatives)
        recall = len(TP) / (len(TP)+len(FN))
        # F1 = 2 * (Recall * Precision) / (Recall + Precision)
        f1 = 2 * (recall*precision)/ (recall+precision)
        print('F1 = {}, Precision = {}, Recall = {}'.format(round(f1,2),round(precision,2),round(recall,2)))


precision = len(TruePositive)/(len(TruePositive)+len(FalsePositive))
# Recall = True positives / (True positives + False negatives)
recall = len(TruePositive) / (len(TruePositive)+len(FalseNegative))
# F1 = 2 * (Recall * Precision) / (Recall + Precision)
f1 = 2 * (recall*precision)/ (recall+precision)
# distance
print()
print()

print('Criteria for True Positive = {}ms'.format(closeness_criteria*1000))
average_distance = sum(distance)/len(distance)
print('Average distance in True Positive = {}ms'.format(round (average_distance/1024,5)*1000))

print('Total points for subject {} = {}, True Positive = {}, False Positive = {}, False Negative = {}, '.format(name_subject,len(all_points),len(TruePositive),len(FalsePositive),len(FalseNegative)))
print('F1 = {}, Precision = {}, Recall = {}'.format(round(f1,2),round(precision,2),round(recall,2)))